# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.eventnetworkwanstatus_ppp import EVENTNETWORKWANSTATUSPpp  # noqa: F401,E501
from swagger_server import util


class EVENTNETWORKWANSTATUS(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, enable: bool=True, apn: str='telefonica.es', network_user_id: str='abc', authentication_method: str='PAP', prefered_network: str='4G', ppp: EVENTNETWORKWANSTATUSPpp=EVENTNETWORKWANSTATUSPpp()):  # noqa: E501
        """EVENTNETWORKWANSTATUS - a model defined in Swagger

        :param enable: The enable of this EVENTNETWORKWANSTATUS.  # noqa: E501
        :type enable: bool
        :param apn: The apn of this EVENTNETWORKWANSTATUS.  # noqa: E501
        :type apn: str
        :param network_user_id: The network_user_id of this EVENTNETWORKWANSTATUS.  # noqa: E501
        :type network_user_id: str
        :param authentication_method: The authentication_method of this EVENTNETWORKWANSTATUS.  # noqa: E501
        :type authentication_method: str
        :param prefered_network: The prefered_network of this EVENTNETWORKWANSTATUS.  # noqa: E501
        :type prefered_network: str
        :param ppp: The ppp of this EVENTNETWORKWANSTATUS.  # noqa: E501
        :type ppp: EVENTNETWORKWANSTATUSPpp
        """
        self.swagger_types = {
            'enable': bool,
            'apn': str,
            'network_user_id': str,
            'authentication_method': str,
            'prefered_network': str,
            'ppp': EVENTNETWORKWANSTATUSPpp
        }

        self.attribute_map = {
            'enable': 'enable',
            'apn': 'apn',
            'network_user_id': 'network_user_id',
            'authentication_method': 'authentication_method',
            'prefered_network': 'prefered_network',
            'ppp': 'ppp'
        }
        self._enable = enable
        self._apn = apn
        self._network_user_id = network_user_id
        self._authentication_method = authentication_method
        self._prefered_network = prefered_network
        self._ppp = ppp

    @classmethod
    def from_dict(cls, dikt) -> 'EVENTNETWORKWANSTATUS':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The EVENT_NETWORK_WAN_STATUS of this EVENTNETWORKWANSTATUS.  # noqa: E501
        :rtype: EVENTNETWORKWANSTATUS
        """
        return util.deserialize_model(dikt, cls)

    @property
    def enable(self) -> bool:
        """Gets the enable of this EVENTNETWORKWANSTATUS.


        :return: The enable of this EVENTNETWORKWANSTATUS.
        :rtype: bool
        """
        return self._enable

    @enable.setter
    def enable(self, enable: bool):
        """Sets the enable of this EVENTNETWORKWANSTATUS.


        :param enable: The enable of this EVENTNETWORKWANSTATUS.
        :type enable: bool
        """

        self._enable = enable

    @property
    def apn(self) -> str:
        """Gets the apn of this EVENTNETWORKWANSTATUS.

        Access Point Name  # noqa: E501

        :return: The apn of this EVENTNETWORKWANSTATUS.
        :rtype: str
        """
        return self._apn

    @apn.setter
    def apn(self, apn: str):
        """Sets the apn of this EVENTNETWORKWANSTATUS.

        Access Point Name  # noqa: E501

        :param apn: The apn of this EVENTNETWORKWANSTATUS.
        :type apn: str
        """

        self._apn = apn

    @property
    def network_user_id(self) -> str:
        """Gets the network_user_id of this EVENTNETWORKWANSTATUS.


        :return: The network_user_id of this EVENTNETWORKWANSTATUS.
        :rtype: str
        """
        return self._network_user_id

    @network_user_id.setter
    def network_user_id(self, network_user_id: str):
        """Sets the network_user_id of this EVENTNETWORKWANSTATUS.


        :param network_user_id: The network_user_id of this EVENTNETWORKWANSTATUS.
        :type network_user_id: str
        """

        self._network_user_id = network_user_id

    @property
    def authentication_method(self) -> str:
        """Gets the authentication_method of this EVENTNETWORKWANSTATUS.


        :return: The authentication_method of this EVENTNETWORKWANSTATUS.
        :rtype: str
        """
        return self._authentication_method

    @authentication_method.setter
    def authentication_method(self, authentication_method: str):
        """Sets the authentication_method of this EVENTNETWORKWANSTATUS.


        :param authentication_method: The authentication_method of this EVENTNETWORKWANSTATUS.
        :type authentication_method: str
        """
        allowed_values = ["PAP", "CHAP"]  # noqa: E501
        if authentication_method not in allowed_values:
            raise ValueError(
                "Invalid value for `authentication_method` ({0}), must be one of {1}"
                .format(authentication_method, allowed_values)
            )

        self._authentication_method = authentication_method

    @property
    def prefered_network(self) -> str:
        """Gets the prefered_network of this EVENTNETWORKWANSTATUS.


        :return: The prefered_network of this EVENTNETWORKWANSTATUS.
        :rtype: str
        """
        return self._prefered_network

    @prefered_network.setter
    def prefered_network(self, prefered_network: str):
        """Sets the prefered_network of this EVENTNETWORKWANSTATUS.


        :param prefered_network: The prefered_network of this EVENTNETWORKWANSTATUS.
        :type prefered_network: str
        """
        allowed_values = ["GRPS", "3G", "4G"]  # noqa: E501
        if prefered_network not in allowed_values:
            raise ValueError(
                "Invalid value for `prefered_network` ({0}), must be one of {1}"
                .format(prefered_network, allowed_values)
            )

        self._prefered_network = prefered_network

    @property
    def ppp(self) -> EVENTNETWORKWANSTATUSPpp:
        """Gets the ppp of this EVENTNETWORKWANSTATUS.


        :return: The ppp of this EVENTNETWORKWANSTATUS.
        :rtype: EVENTNETWORKWANSTATUSPpp
        """
        return self._ppp

    @ppp.setter
    def ppp(self, ppp: EVENTNETWORKWANSTATUSPpp):
        """Sets the ppp of this EVENTNETWORKWANSTATUS.


        :param ppp: The ppp of this EVENTNETWORKWANSTATUS.
        :type ppp: EVENTNETWORKWANSTATUSPpp
        """

        self._ppp = ppp
